commit 3eb3fbc89c638a72611efdc54110b8113f79ee8d
Author: Stefan Schulze Frielinghaus <stefansf@gcc.gnu.org>
Date:   Thu Sep 26 19:38:02 2024 +0200

    s390: Fix TF to FPRX2 conversion [PR115860]
    
    Currently subregs originating from *tf_to_fprx2_0 and *tf_to_fprx2_1
    survive register allocation.  This in turn leads to wrong register
    renaming.  Keeping the current approach would mean we need two insns for
    *tf_to_fprx2_0 and *tf_to_fprx2_1, respectively.  Something along the
    lines
    
    (define_insn "*tf_to_fprx2_0"
      [(set (subreg:DF (match_operand:FPRX2 0 "nonimmediate_operand" "=f") 0)
            (unspec:DF [(match_operand:TF 1 "general_operand" "v")]
                       UNSPEC_TF_TO_FPRX2_0))]
      "TARGET_VXE"
      "#")
    
    (define_insn "*tf_to_fprx2_0"
      [(set (match_operand:DF 0 "nonimmediate_operand" "=f")
            (unspec:DF [(match_operand:TF 1 "general_operand" "v")]
                       UNSPEC_TF_TO_FPRX2_0))]
      "TARGET_VXE"
      "vpdi\t%v0,%v1,%v0,1
      [(set_attr "op_type" "VRR")])
    
    and similar for *tf_to_fprx2_1.  Note, pre register allocation operand 0
    has mode FPRX2 and afterwards DF once subregs have been eliminated.
    
    Since we always copy a whole vector register into a floating-point
    register pair, another way to fix this is to merge *tf_to_fprx2_0 and
    *tf_to_fprx2_1 into a single insn which means we don't have to use
    subregs at all.  The downside of this is that the assembler template
    contains two instructions, now.  The upside is that we don't have to
    come up with some artificial insn before RA which might be more
    readable/maintainable.  That is implemented by this patch.
    
    In commit r11-4872-ge627cda5686592, the output operand specifier %V was
    introduced which is used in tf_to_fprx2 only, now.  Instead of coming up
    with its counterpart %F for floating-point registers, which would also
    only be used in tf_to_fprx2, I print the operands directly.  This
    renders %V unused which is why it is removed by this patch.
    
    gcc/ChangeLog:
    
            PR target/115860
            * config/s390/s390.cc (print_operand): Remove operand specifier
            %V.
            * config/s390/s390.md (UNSPEC_TF_TO_FPRX2): New.
            * config/s390/vector.md (*tf_to_fprx2_0): Remove.
            (*tf_to_fprx2_1): Remove.
            (tf_to_fprx2): New.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/s390/vector/long-double-asm-abi.c: Adapt
            scan-assembler directive.
            * gcc.target/s390/vector/long-double-to-i64.c: Adapt
            scan-assembler directive.
            * gcc.target/s390/pr115860-1.c: New test.
    
    (cherry picked from commit 46c2538435dfc50dd5c67c4e03ce387d1f6ebe9b)

diff --git a/gcc/config/s390/s390.cc b/gcc/config/s390/s390.cc
index 2619a9ac986..a1c0a57a795 100644
--- a/gcc/config/s390/s390.cc
+++ b/gcc/config/s390/s390.cc
@@ -8466,7 +8466,6 @@ print_operand_address (FILE *file, rtx addr)
 	 CONST_VECTOR: Generate a bitmask for vgbm instruction.
     'x': print integer X as if it's an unsigned halfword.
     'v': print register number as vector register (v1 instead of f1).
-    'V': print the second word of a TFmode operand as vector register.
 */
 
 void
@@ -8659,13 +8658,13 @@ print_operand (FILE *file, rtx x, int code)
     case REG:
       /* Print FP regs as fx instead of vx when they are accessed
 	 through non-vector mode.  */
-      if ((code == 'v' || code == 'V')
+      if (code == 'v'
 	  || VECTOR_NOFP_REG_P (x)
 	  || (FP_REG_P (x) && VECTOR_MODE_P (GET_MODE (x)))
 	  || (VECTOR_REG_P (x)
 	      && (GET_MODE_SIZE (GET_MODE (x)) /
 		  s390_class_max_nregs (FP_REGS, GET_MODE (x))) > 8))
-	fprintf (file, "%%v%s", reg_names[REGNO (x) + (code == 'V')] + 2);
+	fprintf (file, "%%v%s", reg_names[REGNO (x)] + 2);
       else
 	fprintf (file, "%s", reg_names[REGNO (x)]);
       break;
diff --git a/gcc/testsuite/gcc.target/s390/pr115860-1.c b/gcc/testsuite/gcc.target/s390/pr115860-1.c
new file mode 100644
index 00000000000..abcddeaed95
--- /dev/null
+++ b/gcc/testsuite/gcc.target/s390/pr115860-1.c
@@ -0,0 +1,26 @@
+/* { dg-do run } */
+/* { dg-require-effective-target s390_vxe } */
+/* { dg-options "-O2 -march=z14 -mzarch" } */
+
+__attribute__ ((noipa))
+long long trunctf (long double x)
+{
+  /* Ensure via ++x that x is in a register.  */
+  ++x;
+  return x;
+}
+
+__attribute__ ((noipa))
+long long trunctf_from_mem (long double x)
+{
+  return x;
+}
+
+int main (void)
+{
+  if (trunctf (0x7ffffffffffffffeLL) != 0x7fffffffffffffffLL)
+    __builtin_abort ();
+  if (trunctf_from_mem (0x7fffffffffffffffLL) != 0x7fffffffffffffffLL)
+    __builtin_abort ();
+  return 0;
+}
diff --git a/gcc/testsuite/gcc.target/s390/vector/long-double-asm-abi.c b/gcc/testsuite/gcc.target/s390/vector/long-double-asm-abi.c
index f9f2d1286e2..ac3576801f0 100644
--- a/gcc/testsuite/gcc.target/s390/vector/long-double-asm-abi.c
+++ b/gcc/testsuite/gcc.target/s390/vector/long-double-asm-abi.c
@@ -14,7 +14,7 @@ xsqrt (long double x)
 
 /* Check that the generated code is very small and straightforward.  In
    particular, there must be no unnecessary copying and no stack frame.  */
-/* { dg-final { scan-assembler {\n\tld\t[^\n]*\n\tld\t[^\n]*\n(#[^\n]*\n)*\tsqxbr\t.*\n(#[^\n]*\n)*\tstd\t[^\n]*\n\tstd\t[^\n]*\n\tbr\t%r14\n} } } */
+/* { dg-final { scan-assembler {\n\tld\t[^\n]*;ld\t[^\n]*\n(#[^\n]*\n)*\tsqxbr\t.*\n(#[^\n]*\n)*\tstd\t[^\n]*\n\tstd\t[^\n]*\n\tbr\t%r14\n} } } */
 
 int
 main (void)
diff --git a/gcc/testsuite/gcc.target/s390/vector/long-double-to-i64.c b/gcc/testsuite/gcc.target/s390/vector/long-double-to-i64.c
index 2dbbb5d1c03..ed47fd9b858 100644
--- a/gcc/testsuite/gcc.target/s390/vector/long-double-to-i64.c
+++ b/gcc/testsuite/gcc.target/s390/vector/long-double-to-i64.c
@@ -10,8 +10,6 @@ long_double_to_i64 (long double x)
   return x;
 }
 
-/* { dg-final { scan-assembler-times {\n\tvpdi\t%v\d+,%v\d+,%v\d+,1\n} 1 } } */
-/* { dg-final { scan-assembler-times {\n\tvpdi\t%v\d+,%v\d+,%v\d+,5\n} 1 } } */
 /* { dg-final { scan-assembler-times {\n\tcgxbr\t} 1 } } */
 
 int

